/* 
 * Copyright (C) 2001-2013 Michael Fuchs
 *
 * This file is part of herold.
 * 
 * herold is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * herold is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with herold.  If not, see <http://www.gnu.org/licenses/>.  
 */
package org.dbdoclet.trafo.internal.html.docbook.editor;

import org.dbdoclet.tag.docbook.BaseTagFactory;
import org.dbdoclet.tag.docbook.DocBookElement;
import org.dbdoclet.tag.docbook.Entry;
import org.dbdoclet.tag.docbook.Example;
import org.dbdoclet.tag.docbook.Informalexample;
import org.dbdoclet.tag.docbook.SectionElement;
import org.dbdoclet.tag.html.HtmlElement;
import org.dbdoclet.trafo.html.EditorException;
import org.dbdoclet.trafo.html.EditorInstruction;
import org.dbdoclet.xiphias.dom.NodeImpl;

public class PreEditor extends DocBookEditor {

	@Override
	public EditorInstruction edit(EditorInstruction values)
			throws EditorException {

		setValues(super.edit(values));
		BaseTagFactory dbfactory = getTagFactory();
		HtmlElement pre = values.getHtmlElement();

		DocBookElement candidate;
		NodeImpl parent = getParent();

		if (getParent() instanceof Entry) {

			candidate = dbfactory.createScreen();

		} else if (getParent() instanceof Example
				|| getParent() instanceof Informalexample) {

			candidate = dbfactory.createProgramlisting();

		} else {

			candidate = dbfactory.createScreen();
		}

		String attrLang = pre.getAttribute("lang");
		if (attrLang != null) {
			candidate.setAttribute("language", attrLang);
		}

		candidate.setParentNode(parent);

		if (candidate.isValidParent(script.getTransformPosition(), parent)) {

			setCurrent(candidate);
			parent.appendChild(candidate);

		} else {

			if (isSection(parent)) {

				SectionElement sect = (SectionElement) parent;
				SectionElement firstSectionChild = sect.getFirstSectionChild();

				if (firstSectionChild != null) {

					setCurrent(candidate);
					parent.insertBefore(candidate, firstSectionChild);
				}
			}
		}

		traverse(true);

		return finalizeValues();
	}
}
